diff --git a/src/backend/catalog/partition.c b/src/backend/catalog/partition.c
index f17ac29..4f840c1 100644
--- a/src/backend/catalog/partition.c
+++ b/src/backend/catalog/partition.c
@@ -13,38 +13,41 @@
  *-------------------------------------------------------------------------
 */
 
 #include "postgres.h"
 
 #include "access/heapam.h"
 #include "access/htup_details.h"
 #include "access/nbtree.h"
 #include "access/sysattr.h"
 #include "catalog/dependency.h"
+#include "catalog/heap.h"
 #include "catalog/indexing.h"
 #include "catalog/objectaddress.h"
 #include "catalog/partition.h"
 #include "catalog/pg_collation.h"
 #include "catalog/pg_inherits.h"
 #include "catalog/pg_inherits_fn.h"
 #include "catalog/pg_opclass.h"
 #include "catalog/pg_partitioned_table.h"
 #include "catalog/pg_partitioned_table_fn.h"
 #include "catalog/pg_type.h"
 #include "executor/executor.h"
 #include "miscadmin.h"
 #include "nodes/makefuncs.h"
 #include "nodes/nodeFuncs.h"
 #include "nodes/parsenodes.h"
 #include "optimizer/clauses.h"
+#include "optimizer/cost.h"
 #include "optimizer/planmain.h"
 #include "optimizer/var.h"
+#include "rewrite/rewriteManip.h"
 #include "storage/lmgr.h"
 #include "utils/array.h"
 #include "utils/builtins.h"
 #include "utils/datum.h"
 #include "utils/memutils.h"
 #include "utils/fmgroids.h"
 #include "utils/inval.h"
 #include "utils/lsyscache.h"
 #include "utils/ruleutils.h"
 #include "utils/rel.h"
@@ -158,20 +161,50 @@ typedef struct PartitionTreeNodeData
 	PartitionDesc		pdesc;
 	Oid					relid;
 	int					index;
 	int					offset;
 	int					num_leaf_parts;
 
 	struct PartitionTreeNodeData *downlink;
 	struct PartitionTreeNodeData *next;
 } PartitionTreeNodeData;
 
+/*
+ * Partitioning scheme
+ *		Structure to hold partitioning scheme for a given relation.
+ *
+ * Multiple relations may be partitioned in the same way. The relations
+ * resulting from joining such relations may be partitioned in the same way as
+ * the joining relations.  Similarly, relations derived from such relations by
+ * grouping, sorting be partitioned in the same as the underlying relations.
+ *
+ * PlannerInfo stores a list of distinct "canonical" partitioning schemes.
+ * RelOptInfo of a partitioned relation holds the pointer to "canonical"
+ * partitioning scheme.
+ */
+typedef struct PartitionSchemeData
+{
+	/* Information about partitions */
+	int			nparts;		/* number of partitions */
+	PartitionListInfo	  **lists;		/* list bounds */
+	PartitionRangeInfo	  **ranges;	/* range lower bounds */
+
+	/* Information about partition keys */
+	char		strategy;		/* partition strategy */
+	int16		partnatts;		/* number of partition attributes */
+	Oid		   *partopfamily;	/* OIDs of operator families */
+	Oid		   *partopcintype;	/* OIDs of opclass declared input data types */
+	Oid		   *key_types;		/* OIDs of partition key data types. */
+	int32	   *key_typmods;	/* typmods of partition keys. */
+	Oid		   *key_collations;	/* OIDs of collations of partition keys. */
+} PartitionSchemeData;
+
 /* Support RelationBuildPartitionKey() */
 static PartitionKey copy_partition_key(PartitionKey fromkey);
 static KeyTypeCollInfo *copy_key_type_coll_info(int nkeycols,
 								KeyTypeCollInfo *tcinfo);
 
 /* Support RelationBuildPartitionDesc() */
 static int32 partition_cmp(const void *a, const void *b, void *arg);
 
 /* Support check_new_partition_bound() */
 static bool list_overlaps_existing_partition(PartitionKey key,
@@ -222,20 +255,23 @@ static int range_partition_for_tuple(PartitionKey key, PartitionDesc pdesc,
 
 /* List partition related support functions */
 static PartitionListInfo *make_list_from_spec(PartitionKey key,
 							PartitionListSpec *list_spec);
 static PartitionListInfo *copy_list_info(PartitionListInfo *src,
 							PartitionKey key);
 static bool equal_list_info(PartitionKey key, PartitionListInfo *l1,
 				PartitionListInfo *l2);
 static bool partition_list_values_equal(PartitionKey key,
 						   Datum val1, Datum val2);
+static bool have_same_partition_lists(PartitionDesc part_desc,
+									  PartitionKey part_key,
+									  PartitionScheme part_scheme);
 
 /* Range partition related support functions */
 static PartitionRangeInfo *make_range_from_spec(PartitionKey key,
 							PartitionRangeSpec *range_spec);
 static RangeBound *make_range_bound(PartitionKey key, List *val, bool inclusive,
 							bool lower);
 static PartitionRangeInfo *copy_range_info(PartitionRangeInfo *src,
 							PartitionKey key);
 static RangeBound *copy_range_bound(RangeBound *src, PartitionKey key);
 static bool equal_range_info(PartitionKey key, PartitionRangeInfo *r1,
@@ -245,20 +281,23 @@ static int32 partition_range_cmp(PartitionKey key, PartitionRangeInfo *r1,
 static int32 partition_range_bound_cmp(PartitionKey key, RangeBound *b1,
 							RangeBound *b2);
 static int32 partition_range_tuple_cmp(PartitionKey key,
 						   Datum *val1, Datum *val2);
 static bool partition_range_overlaps(PartitionKey key,
 							PartitionRangeInfo *r1, PartitionRangeInfo *r2);
 static bool tuple_rightof_bound(PartitionKey key, Datum *tuple, RangeBound *bound);
 static bool tuple_leftof_bound(PartitionKey key, Datum *tuple, RangeBound *bound);
 static int range_partition_bsearch(PartitionKey key, PartitionDesc pdesc,
 						Datum *tuple);
+static bool have_same_partition_bounds(PartitionDesc part_desc,
+								PartitionKey part_key,
+								PartitionScheme part_scheme);
 
 /*
  * Partition key related functions
  */
 
 /*
  * RelationBuildPartitionKey
  *		Build and attach to relcache partition key data of relation
  *
  * Note that the partition key data attached to a relcache entry must be
@@ -2358,10 +2397,357 @@ tuple_rightof_bound(PartitionKey key, Datum *tuple, RangeBound *bound)
 static bool
 tuple_leftof_bound(PartitionKey key, Datum *tuple, RangeBound *bound)
 {
 	int32	cmpval = partition_range_tuple_cmp(key, tuple, bound->val);
 
 	if (!cmpval)
 		return !bound->lower ? bound->inclusive : !bound->inclusive;
 
 	return cmpval < 0;
 }
+
+/*
+ * find_partition_scheme
+ * 		Find the "canonical" partition scheme for the given base table.
+ *
+ * 	The function searches the list of canonical partition schemes for one that
+ * 	exactly matches the partitioning properties of the given relation. If it
+ * 	does not find one, the function creates a canonical partition scheme
+ * 	structure and adds it to the list.
+ *
+ * 	For an umpartitioned table, it returns NULL.
+ */
+extern PartitionScheme
+find_partition_scheme(PlannerInfo *root, Relation relation)
+{
+	PartitionKey	part_key = RelationGetPartitionKey(relation);
+	PartitionDesc	part_desc = RelationGetPartitionDesc(relation);
+	ListCell	   *lc;
+	int		nparts;
+	int		partnatts;
+	int		cnt_pks;
+	int		cnt_parts;
+	PartitionScheme	part_scheme = NULL;
+
+	/* No partition scheme for an unpartitioned relation. */
+	if (!part_desc || !part_key)
+		return NULL;
+
+	nparts = part_desc->nparts;
+	partnatts = part_key->partnatts;
+
+	/* Search for a matching partition scheme and return if found one. */
+	foreach (lc, root->part_schemes)
+	{
+		part_scheme = lfirst(lc);
+
+		/* Match number of partitions and partitioning strategy. */
+		if (nparts != part_scheme->nparts ||
+			part_key->strategy != part_scheme->strategy ||
+			partnatts != part_scheme->partnatts)
+			continue;
+
+		/* Match the partition key types. */
+		for (cnt_pks = 0; cnt_pks < partnatts; cnt_pks++)
+		{
+			/*
+			 * It suffices to check the OID of support function as it always has
+			 * two arguemnts and returns boolean. For types, it suffices to match
+			 * the type id, mod and collation; len, byval and align are depedent on
+			 * the first two.
+			 */
+			if (part_key->partopfamily[cnt_pks] != part_scheme->partopfamily[cnt_pks] ||
+				part_key->partopcintype[cnt_pks] != part_scheme->partopcintype[cnt_pks] ||
+				part_key->tcinfo->typid[cnt_pks] != part_scheme->key_types[cnt_pks] ||
+				part_key->tcinfo->typmod[cnt_pks] != part_scheme->key_typmods[cnt_pks] ||
+				part_key->tcinfo->typcoll[cnt_pks] != part_scheme->key_collations[cnt_pks])
+				break;
+		}
+
+		/* Some partition key didn't match. Check next partitioning scheme. */
+		if (cnt_pks < partnatts)
+			continue;
+
+		/* Match partition bounds or lists. */
+		switch (part_scheme->strategy)
+		{
+			case PARTITION_STRAT_LIST:
+				if (!have_same_partition_lists(part_desc, part_key,
+											   part_scheme))
+					continue;
+				break;
+
+			case PARTITION_STRAT_RANGE:
+				if (!have_same_partition_bounds(part_desc, part_key,
+												part_scheme))
+					continue;
+				break;
+
+			default:
+				/* Unknown partition strategy. */
+				elog(ERROR, "unknown partition strategy code %d",
+					 part_key->strategy);
+				break;
+		}
+
+		/* Found matching partition scheme. */
+		return part_scheme;
+	}
+
+	/* Did not find matching partition scheme. Create one. */
+	part_scheme = (PartitionScheme) palloc0(sizeof(PartitionSchemeData));
+
+	/* Copy partition bounds/lists. */
+	part_scheme->nparts = part_desc->nparts;
+	part_scheme->strategy = part_key->strategy;
+	switch (part_scheme->strategy)
+	{
+		case PARTITION_STRAT_LIST:
+			part_scheme->lists = (PartitionListInfo **) palloc(sizeof(PartitionListInfo *) * nparts);
+			part_scheme->ranges = NULL;
+			for (cnt_parts = 0; cnt_parts < nparts; cnt_parts++)
+				part_scheme->lists[cnt_parts] = copy_list_info(part_desc->parts[cnt_parts]->list,
+															   part_key);
+			break;
+
+		case PARTITION_STRAT_RANGE:
+			part_scheme->ranges = (PartitionRangeInfo **) palloc(sizeof(PartitionRangeInfo *) * nparts);
+			part_scheme->lists = NULL;
+			for (cnt_parts = 0; cnt_parts < nparts; cnt_parts++)
+				part_scheme->ranges[cnt_parts] = copy_range_info(part_desc->parts[cnt_parts]->range,
+																 part_key);
+			break;
+
+		default:
+			elog(ERROR, "unknown partition strategy code %d",
+				 part_key->strategy);
+			break;
+	}
+
+	/* Store partition key information. */
+	part_scheme->partnatts = part_key->partnatts;
+
+	part_scheme->partopfamily = (Oid *) palloc(sizeof(Oid) * partnatts);
+	part_scheme->partopcintype = (Oid *) palloc(sizeof(Oid) * partnatts);
+	part_scheme->key_types = (Oid *) palloc(sizeof(Oid) * partnatts);
+	part_scheme->key_typmods = (int32 *) palloc(sizeof(int32) * partnatts);
+	part_scheme->key_collations = (Oid *) palloc(sizeof(Oid) * partnatts);
+
+	for (cnt_pks = 0; cnt_pks < partnatts; cnt_pks++)
+	{
+		part_scheme->partopfamily[cnt_pks] = part_key->partopfamily[cnt_pks];
+		part_scheme->partopcintype[cnt_pks] = part_key->partopcintype[cnt_pks];
+		part_scheme->key_types[cnt_pks] = part_key->tcinfo->typid[cnt_pks];
+		part_scheme->key_typmods[cnt_pks] = part_key->tcinfo->typmod[cnt_pks];
+		part_scheme->key_collations[cnt_pks] = part_key->tcinfo->typcoll[cnt_pks];
+	}
+
+	/* Add the partitioning scheme to PlannerInfo. */
+	root->part_schemes = lappend(root->part_schemes, part_scheme);
+
+	return part_scheme;
+}
+
+/*
+ * have_same_partition_lists
+ *
+ * For given list partitioned relations, return true if lists for all the
+ * partitions of both the relations match. Return false otherwise.
+ */
+static bool
+have_same_partition_lists(PartitionDesc part_desc, PartitionKey part_key,
+						  PartitionScheme part_scheme)
+{
+	int		cnt_parts;
+
+	Assert(part_scheme->strategy == part_key->strategy);
+	Assert(part_key->strategy == PARTITION_STRAT_LIST &&
+		   part_key->strategy == PARTITION_STRAT_LIST);
+
+	Assert(part_scheme->nparts == part_desc->nparts);
+
+	/* List partition has only one partition key. */
+	Assert(part_key->partnatts == 1 && part_scheme->partnatts == 1);
+
+	for (cnt_parts = 0; cnt_parts < part_desc->nparts; cnt_parts++)
+	{
+		if (!equal_list_info(part_key, part_scheme->lists[cnt_parts],
+							 part_desc->parts[cnt_parts]->list))
+			return false;
+	}
+
+	/* Ok, everything matches, return true. */
+	return true;
+}
+
+/*
+ * have_same_partition_bounds
+ *
+ * For given partitioned relations, return true if the bounds of all the
+ * partitions of the both the relations match. Return false otherwise.
+ */
+static bool
+have_same_partition_bounds(PartitionDesc part_desc, PartitionKey part_key,
+						   PartitionScheme part_scheme)
+{
+	int		cnt_parts;
+	Assert(part_key->strategy == PARTITION_STRAT_RANGE &&
+		   part_scheme->strategy == PARTITION_STRAT_RANGE);
+
+	Assert(part_desc->nparts == part_scheme->nparts);
+
+	for (cnt_parts = 0; cnt_parts < part_desc->nparts; cnt_parts++)
+	{
+		if (!equal_range_info(part_key, part_scheme->ranges[cnt_parts],
+							  part_desc->parts[cnt_parts]->range))
+			return false;
+	}
+
+	/* Ok, everything matches. */
+	return true;
+}
+
+extern List **
+build_baserel_partition_keys(PlannerInfo *root, Relation relation, Index varno)
+{
+	PartitionKey	part_key = RelationGetPartitionKey(relation);
+	int		num_pkexprs;
+	int		cnt_pke;
+	List		  **partexprs;
+	ListCell	   *lc;
+
+	if (!part_key || part_key->partnatts <= 0)
+		return NULL;
+
+	num_pkexprs = part_key->partnatts;
+
+	/* Store partition keys as single elements lists. */
+	partexprs = (List **) palloc(sizeof(List *) * num_pkexprs);
+
+	lc = list_head(part_key->partexprs);
+	for (cnt_pke = 0; cnt_pke < num_pkexprs; cnt_pke++)
+	{
+		AttrNumber attno = part_key->partattrs[cnt_pke];
+		Expr	  *pkexpr;
+
+		if (attno != InvalidAttrNumber)
+		{
+			/* Single column partition key is stored as a Var node. */
+			Form_pg_attribute att_tup;
+
+			if (attno < 0)
+				att_tup = SystemAttributeDefinition(attno,
+												relation->rd_rel->relhasoids);
+			else
+				att_tup = relation->rd_att->attrs[attno - 1];
+
+			pkexpr = (Expr *) makeVar(varno, attno, att_tup->atttypid,
+									  att_tup->atttypmod,
+									  att_tup->attcollation, 0);
+		}
+		else
+		{
+			if (!lc)
+				elog(ERROR, "wrong number of partition key expressions");
+			pkexpr = (Expr *) copyObject(lfirst(lc));
+			ChangeVarNodes((Node *) pkexpr, 1, varno, 0);
+			lc = lnext(lc);
+		}
+
+		partexprs[cnt_pke] = list_make1(pkexpr);
+	}
+
+	return partexprs;
+}
+
+/*
+ * Returns the number of partitions supported by the given partition scheme.
+ */
+extern int
+PartitionSchemeGetNumParts(PartitionScheme part_scheme)
+{
+	return part_scheme ? part_scheme->nparts : 0;
+}
+
+/*
+ * Returns the number of partition keys supported by the given partition
+ * scheme.
+ */
+extern int
+PartitionSchemeGetNumKeys(PartitionScheme part_scheme)
+{
+	return part_scheme ? part_scheme->partnatts : 0;
+}
+
+/*
+ * Set up partitioning scheme and partition keys for a join between given two
+ * relations.
+ */
+extern void
+build_joinrel_partition_info(RelOptInfo *joinrel, RelOptInfo *outer_rel,
+							 RelOptInfo *inner_rel, JoinType jointype)
+{
+	int		num_pks;
+	int		cnt;
+
+	/*
+	 * Nothing to do if
+	 * a. partition-wise join is disabled.
+	 * b. joining relations are not partitioned.
+	 * c. partitioning schemes do not match.
+	 */
+	if (!enable_partition_wise_join ||
+		!outer_rel->part_scheme || !inner_rel->part_scheme ||
+		outer_rel->part_scheme != inner_rel->part_scheme)
+	{
+		joinrel->part_scheme = NULL;
+		return;
+	}
+
+	/*
+	 * This function will be called only once for each joinrel and thus we
+	 * should not see partition scheme, partition keys and array for storing
+	 * child relations set.
+	 */
+	Assert(!joinrel->part_scheme && !joinrel->partexprs &&
+		   !joinrel->part_rels);
+
+	num_pks = outer_rel->part_scheme->partnatts;
+
+	/* Join relation is partitioned in the same way as the joining relation. */
+	joinrel->part_scheme = outer_rel->part_scheme;
+
+	/*
+	 * Collect the partition key expressions.
+	 * TODO: for an outer join we may want to exclude the inner side. For
+	 * a FULL OUTER join this means, that it doesn't have any partition
+	 * keys.
+	 */
+	joinrel->partexprs = (List **) palloc0(sizeof(List *) * num_pks);
+	for (cnt = 0; cnt < num_pks; cnt++)
+	{
+		List *pkexpr = list_copy(outer_rel->partexprs[cnt]);
+
+		pkexpr = list_concat(pkexpr,
+							 list_copy(inner_rel->partexprs[cnt]));
+		joinrel->partexprs[cnt] = pkexpr;
+	}
+}
+
+/*
+ * Return palloc'ed array of OIDs of partitions.
+ */
+extern Oid *
+PartitionDescGetPartOids(PartitionDesc part_desc)
+{
+	Oid	   *part_oids;
+	int		cnt_parts;
+
+	if (!part_desc || part_desc->nparts <= 0)
+		return NULL;
+
+	part_oids = (Oid *) palloc(sizeof(Oid) * part_desc->nparts);
+	for (cnt_parts = 0; cnt_parts < part_desc->nparts; cnt_parts++)
+		part_oids[cnt_parts] = part_desc->parts[cnt_parts]->oid;
+
+	return part_oids;
+}
diff --git a/src/backend/nodes/outfuncs.c b/src/backend/nodes/outfuncs.c
index 3b8fa6b..cd14840 100644
--- a/src/backend/nodes/outfuncs.c
+++ b/src/backend/nodes/outfuncs.c
@@ -204,20 +204,31 @@ _outBitmapset(StringInfo str, const Bitmapset *bms)
 }
 
 /* for use by extensions which define extensible nodes */
 void
 outBitmapset(StringInfo str, const Bitmapset *bms)
 {
 	_outBitmapset(str, bms);
 }
 
 /*
+ * TODO: remove, used for debugging through gdb.
+ */
+char *
+bms_to_char(const Bitmapset *bms)
+{
+	StringInfo str = makeStringInfo();
+	outBitmapset(str, bms);
+	return str->data;
+}
+
+/*
  * Print the value of a Datum given its type.
  */
 void
 outDatum(StringInfo str, Datum value, int typlen, bool typbyval)
 {
 	Size		length,
 				i;
 	char	   *s;
 
 	length = datumGetSize(value, typbyval, typlen);
